/*
    FEARLUS model0-6-8-2: Double.h
    Copyright (C) 1999-2004, 2007-2008  Macaulay Institute

    This file is part of FEARLUS model0-6-8-2, an agent-based model of land use
    change.

    FEARLUS model0-6-8-2 is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FEARLUS model0-6-8-2 is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details. (LICENCE file in
    this directory.)

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Contact information:
      Gary Polhill,
      Macaulay Institute, Craigiebuckler, Aberdeen, AB15 8QH. United Kingdom
      g.polhill@macaulay.ac.uk
*/

/*

Interface for the Double object. This is intended to implement a floating point
number with range checking for comparison operators. Ideally it should also do
bounds checking, aborting the simulation (optionally?) when the object is
asked to store a number that it cannot represent. The range parameter can be
set once and once only per run.

*/

#import <objc/Object.h>

@interface Double : Object {
  double d;
}

+new;
+new: (double)value;
+setEpsilon: (double)value;
+(double)getEpsilon;
+setFPE: (BOOL)value;
+(BOOL)getFPE;
+(const char **)getTrappableExceptions;
+(const char **)getTrappedExceptions;

-copy;

-set: (double)value;
-(double)get;
-add: (Double *)value;
-sub: (Double *)value;
-mul: (Double *)value;
-div: (Double *)value;

-(BOOL)eq: (Double *)value;
-(BOOL)ne: (Double *)value;
-(BOOL)gt: (Double *)value;
-(BOOL)le: (Double *)value;
-(BOOL)ge: (Double *)value;
-(BOOL)lt: (Double *)value;

@end
